<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
<#comment>判断当前实体是否包含自定义行为</#comment>
<#assign hasServiceEx=false>
<#if item.getAllPSDEActions()??>
    <#list item.getAllPSDEActions() as deaction>
        <#if deaction.isEnableBackend() && deaction.getActionType()=='USERCUSTOM'>
        <#assign hasServiceEx=true>
        <#break>
        </#if>
    </#list>
</#if>
<#if hasServiceEx && (de.getStorageMode()==1 || de.getStorageMode()==2 ||de.getStorageMode()==4||de.getStorageMode()==0 ) >
package ${pub.getPKGCodeName()}.core.extensions.service;

import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.service.impl.${item.codeName}ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.domain.${item.codeName};
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Primary;

/**
 * 实体[${item.getLogicName()}] 自定义服务对象
 */
@Slf4j
@Primary
@Service("${item.codeName}ServiceEx")
public class ${item.codeName}ServiceEx extends ${item.codeName}ServiceImpl {

    <#comment>SQL存储：解决mybatis继承service批操作报错</#comment>
    <#if de.getStorageMode()==1>
    @Override
    protected Class currentModelClass() {
        return com.baomidou.mybatisplus.core.toolkit.ReflectionKit.getSuperClassGenericType(this.getClass().getSuperclass(), 1);
    }
    </#if>

    <#comment>输出实体行为</#comment>
    <#if item.getAllPSDEActions()??>
        <#list item.getAllPSDEActions() as deaction>
            <#if deaction.isEnableBackend() && deaction.getActionType()=='USERCUSTOM'>
    /**
     * 自定义行为[${deaction.getCodeName()}]用户扩展
     * @param et
     * @return
     */
    @Override
    @Transactional
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} et) {
        return super.${srfmethodname(deaction.getCodeName())}(et);
    }
            </#if>
        </#list>
    </#if>
}
</#if>


